package me.map.example;

import me.map.ultimatekingdom.api.UltimateKingdom;
import me.map.ultimatekingdom.api.objects.Kingdom;
import me.map.ultimatekingdom.api.objects.KingdomPlayer;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.HandlerList;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.java.JavaPlugin;

public class Example extends JavaPlugin implements Listener, CommandExecutor {

    private Plugin main;

    @Override
    public void onDisable() {
        HandlerList.unregisterAll(this.main);
    }

    @Override
    public void onEnable() {
        this.main = this;
        Bukkit.getServer().getPluginManager().registerEvents(new Example(), this);
        this.getCommand("test").setExecutor(new Example());

    }

    @EventHandler(priority = EventPriority.LOWEST)
    public void onJoin(PlayerJoinEvent event) {

        if (event.getPlayer() == null) return;
        KingdomPlayer player = UltimateKingdom.Players().getPlayer(event.getPlayer());

       if (player.getKingdom() == null) {
           System.out.println("Player has no kingdom");
       }else {

           System.out.println("Player has kingdom " + player.getKingdom().getName());

            //checking for a kingdom
           if (UltimateKingdom.Kingdoms().getKingdom("MyKingdom") != null) {

               // get the kingdom
               Kingdom kingdom = UltimateKingdom.Kingdoms().getKingdom("MyKingdom");

               // set user in kingdom
               player.setKingdom(kingdom);
               System.out.println("Player is now member of kingdom " + kingdom.getName());

           }
       }

       // teleport player in a few seconds to spawn
       if (player.getKingdom()  != null ) {
            UltimateKingdom.getKingdomServer().TeleportManager().TelePortPlayer(player.getPlayer(), player.getKingdom().getSpawn(),
                "Kingdom Spawn");
       }
    }


    @Override
    public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {

    if (!cmd.getName().equalsIgnoreCase("test")) return true;
        KingdomPlayer kdp    = UltimateKingdom.Players().getPlayer((Player ) sender);
        sender.sendMessage(kdp.getKingdom().getName());

       // if (sender instanceof Player) {
        //    Player player = (Player) sender;

            // Here we need to give items to our player
      //  }
        return true;
    }
}
